# 3.7.1996 copyright Bernhard Reiter (breiter@usf.Uni-Osnabrueck.DE)
#		v1.0.1
#			the GPL (GNU General Public License) applies.
#				send me mail, if you like this hack.... (-:
#
# 	dirty hack to help filled monochrom bar plots with gnuplot (3.6)
#
#	example usage:	gawk -f fill_boxes.awk <input.fig >output.fig
#
#		it is an awk program to run over an gnuplot boxes plot
#		to do two things: 
#					* fill the boxes
#					* get same filled boxes in the keys
#		The program uses the output of the fig terminal driver,
#		i have tested it with gnuplot 3.6b pl336.
#		It produces another x.fig file. (Works on XFig Format 3.1)
#		This can used for further formating or creating postscript...
#		
#	i have used the fig driver with options:
# monochrome small pointsmax 1000 landscape metric
# fontsize 10 thickness 1 depth 10
#
# monochrom is important, small and fontsize might be.
# pointsmax landscape metric thickness and depth can probably be changed.
#
# you need to plot every box with a linetype>1 , like
#	plot 'data1' with boxes linetype 2, '' using 1:3 with boxes linetype 3
# the script needs to find the polyarcs with the different linestyle.
#(you can try without linetypes, but the first plot of boxes will not
# get filled. This is okay, but the first  key does not get an box.)
#
# CHANGES
# 4.7.1997 changed area_fill determination; 40 was undefined and
#	handled different in xfig; now the third linetype of gnuplot
#	should result in filled, black boxes per default.

		# play with the following values:
BEGIN	{
	  lys=-30;	# shift of legend polyarc in y direction; + is down
	  lw=80;	# height of new legend polyarc

	  ps=37;	# used in function get_area_fill, +4 at least
			# in 3.1 pattern start at 41
	}

		# the following function maps gnuplots values in
		# the original fig file at the positions: line_style and
		# style_val (length of dash or gap between points)
		# to fig area_fill values (here patterns)
function get_area_fill( _line_style, _style_val)
{
		# this is linetype 3 of gnuplot
	if(_line_style==1 && _style_val==3)
		return(0);	# for black (because fill_color is white)

		# gnuplot seems to add 3 to area_fill every two linetypes
	return( ps+ _line_style + (2* int(_style_val/3)));
}


#A program of this kind is easy to write, 
#if you read the FORMAT3.1 file in the xfig
#	distribution. Adapt it to your needs.


			# the next two lines take care of , that
			# right_text==1, when the last object was an 
			# 	right justified text
		{ right_text=0;}	# every line starts as non right text
$1==4 && $2==2	{ right_text=1; 	# yeah, we hit a right text object line
		print ;           	# so print it and get the next line
		getline; }		# without starting over again.


$1==2 && $2==1	{	# polyarc	, polyline
			if($3>0)	# other line style
			{
			line_style=$3;
			style_val=$10;
			$3=0;		# solid lines are good
			$6=7;		# fill with white
				if($9==-1)	# not filled
					$9=get_area_fill(line_style,style_val);

				if(right_text)	# if the last object
						# was right justified
				{
					# add three points the the polyarc
				$16+=3; # add the points counter
				print;	# print the first line of the polyarc
					
					# get the points-line of the polyarc
				getline line;
				split(line,array);
				array[2]+=lys;
				array[4]+=lys;
				
				print array[1],array[2],array[3],array[4],\
					array[3],array[4]+lw,array[1],\
					array[4]+lw,\
					array[1],array[2];
				
				next;	# we did the printing already
				}
			}
		}
		
			# all lines
		{
			print;
		}	
